%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function nnet = decouple_all(net)

ss = net.slice_size;
nh = ss/2;

for i = ss+1 : ss+nh
   p = net.CPD{i}.parents;
   np = length(p);
   if np > 1
      net.CPD{i}.theta = zeros(1,np);
      j = find(p==i-ss); % find parent in the same chain
      net.CPD{i}.theta(j) = 1;
   end
end
net.theta = eye(nh);

nnet = net;

return;

