%  run.m
% This program runs a five-fold cross validation experiment
% to evaluate the classification accuracy.

DIR = pwd;
cd /hercules/BNT;
add_BNT_to_path;
cd(DIR);

%% samples1 is all data (10 instances) for class 1
%% samples2 is all data (10 instances) for class 2
load co2am samples;
samples1 = samples;
load co2cm samples;
samples2 = samples;

obss(:,:,1:10) = samples1;
obss(:,:,11:20) = samples2;
clear samples samples1 samples2;

obss = scale(obss,-5,5);
%obss1 = scale(samples1,-5,5);
%obss2 = scale(samples2,-5,5);

obss1 = obss(:,:,1:10);
obss2 = obss(:,:,11:20);
K = [2 6];
da = repmat([1 1 0 0],[5,1]);
T = size(obss1,2);
NM = length(K);
NH = 5;
NO = 1;
discrete = 0;

%M = 10;
M = 1;
rr1 = zeros(1,M);
d1 = zeros(size(da));
rr2 = zeros(1,M);
d2 = zeros(size(da));

rand('state',sum(100*clock));
rand('state',rand(1)*10000);
% repeat 10 times
for ni = 1 : M
   disp(sprintf('ni = %d ......',ni));
   
   d4 = zeros(5,4,2);
   % 5-fold cross validation
   for i = 1 : 5
      disp(sprintf('i = %d ...',i));
      
      i1 = i*2-1;
      i2 = i*2;
      
      test = [i1 i2];
      train = setdiff(1:10,test);
      ntr = length(train);
      nte = length(test);
      
      % chmm
      trdata1 = obss1(K,:,train);
      tedata1 = obss1(K,:,test);
      trdata2 = obss2(K,:,train);
      tedata2 = obss2(K,:,test);
      tedata = zeros(NM,T,nte*2);
      tedata(:,:,1:nte) = tedata1;
      tedata(:,:,nte+1:nte*2) = tedata2;

      err = 1;
      while err == 1
      % initialize network
      %[pi, aij, cjk, mu, sigma] = init_mhmm(samples(K,:,:),NH,NO,'diag',0);
      net01 = chmm_construct(NM,NH,NO,discrete,obss1(K,:,:));
      net02 = chmm_construct(NM,NH,NO,discrete,obss2(K,:,:));
      
      [net1,ll1,err] = chmm_train(trdata1,NM,NH,NO,20,0,net01);
      if err, break; end
      [net2,ll2,err] = chmm_train(trdata2,NM,NH,NO,20,0,net02);
      if err, break; end
      [net3,ll3,err] = chmm_train_exact(trdata1,NM,NH,NO,20,0,net01);
      if err, break; end
      [net4,ll4,err] = chmm_train_exact(trdata2,NM,NH,NO,20,0,net02);
      if err, break; end

      for n = 1 : nte*2
         [alpha,sa,l1(n)] = chmm_forward(net1,tedata(:,:,n));
         [alpha,sa,l2(n)] = chmm_forward(net2,tedata(:,:,n));
         [alpha,sa,l3(n)] = chmm_forward_exact(net3,tedata(:,:,n));
         [alpha,sa,l4(n)] = chmm_forward_exact(net4,tedata(:,:,n));
      end
      
      d1(i,:) = (l1 > l2);
      d2(i,:) = (l3 > l4);

      if err, break; end
      end
      
   end % for i
   
   a = (d1==da);
   rr1(ni) = sum(a(:)) * 5; % chmm
   a = (d2==da);
   rr2(ni) = sum(a(:)) * 5; % chmm-2 (exact)
   
end % for ni

disp(rr1);
disp(rr2);
%save run12_res rr1 rr2

