function y = stochastic(x,d)
%
% y = stochastic(x,d)
%
%    y is a normalized version of x (along dimension d if d is given) 
%    such that sum of y is 1 if x is a vector, sum of each row of y is 1 
%    if x is a matrix.

assert(~isempty(x), 'x is empty');
assert(length(size(x))<=2, 'x is more than 2-dimensional');

if nargin < 2, d = 1; end

if min(size(x)) == 1 & d < 2
    y = x / sum(x);
else
    s = sum(x,2);
    ss = s(:,ones(1,size(x,2)));
    y = x ./ ss;
end

return;
