function bnet = update_bnet(bnet,pi,aij,bjk,th)

% net = update_bnet(bnet, pi, aij, bjk, theta)
%
%    net    - the output bayesian net structure
%    bnet   - the input net structure
%    pi     - the priors
%    aij    - the transition matrices
%    bjk    - the observation matrices
%    th     - the coupling matrix

assert(prod(size(pi)==size(bnet.pi)),'incorrect pi');
assert(prod(size(aij)==size(bnet.aij)),'incorrect aij');
if bnet.discrete == 1
   assert(prod(size(bjk)==size(bnet.bjk)),'incorrect bjk');
else
   assert(prod(size(bjk)==size(bnet.bjo)),'incorrect bjk');
end
assert(prod(size(th)==size(bnet.theta)),'incorrect th');

bnet.pi = pi;
bnet.aij = aij;
if bnet.discrete == 1
   bnet.bjk = bjk;
else
   bnet.bjo = bjk;
end
bnet.theta = th;

nc = max(bnet.equiv_class(:));
n = bnet.slice_size;
nh = n / 2;
for i = 1 : nc
   if i <= nh, bnet.CPD{i}.prior = bnet.pi(:,i)'; end
   if i > nh & i <= n
      if bnet.discrete == 1
         bnet.CPD{i}.CPT = bnet.bjk(:,:,i-nh);
      else
         bnet.CPD{i}.CPT = bnet.bjo(:,:,:,i-nh);
      end
   end
   if i > n
      if nh > 1
         bnet.CPD{i}.theta = (bnet.theta(:,i-n))';
         for j = 1:nh
            bnet.CPD{i}.CPT{j} = bnet.aij(:,:,j,i-n);
         end
      else
         bnet.CPD{i}.CPT = bnet.aij(:,:,i-n,i-n);
      end
   end
end

return;
